import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.*;


@SuppressWarnings("serial")
public class Lancher extends JFrame implements ActionListener {
    private final int N_ALGO = 4;
    private final String files[] = {"att48.tsp", "lin105.tsp", "tsp225.tsp", "att532.tsp"};
    private final int    opt[] = { 10628, 14379, 3916, 27686 }; 
    private JButton buttons[] = new JButton[N_ALGO * files.length];

    public Lancher() {
        setTitle("GraphApplication lancher");
        setSize(600,200);
        setLayout(new GridLayout(files.length, N_ALGO+1));
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        int j=0;
        for (int i=0; i<files.length; i++) {
            JLabel l = new JLabel(files[i].replace(".tsp", ""));
            l.setHorizontalAlignment(JLabel.CENTER);
            l.setFont(GraphApplication.FONT);
            add(l);
            buttons[j++] = addButton("Kruskal");
            buttons[j++] = addButton("Prim");
            buttons[j++] = addButton("Dijkstra");
            buttons[j++] = addButton("TSP");
        }
    }

    private JButton addButton(String name) {
        JButton b = new JButton(name);
        add(b);
        b.setFont(GraphApplication.FONT);
        b.addActionListener(this);
        return b;
    }
    
    public void actionPerformed(ActionEvent e) {
        JButton b = (JButton)e.getSource();
        int j;
        for (j=0; buttons[j]!=b; j++) /**/;
        
        String file = files[j / N_ALGO];
        String name = b.getText() + " : " + file.replace(".tsp", "");
        GraphApplication app = null;
        switch (j % N_ALGO) {
        case 0: app = new Kruskal(name, file); break;
        case 1: app = new Prim(name, file); break;
        case 2: app = new Dijkstra(name, file); break;
        case 3: app = new TSP(name, file, opt[j / N_ALGO]); break;
        }
        app.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
        app.setVisible(true);
        app.start();
    }

    public static void main(String[] args) {
        (new Lancher()).setVisible(true);
    }
}
